unit hiExtConsole;

interface

uses Windows,Kol,Share,Debug;

type
  THIExtConsole = class(TDebug)
   private
   rstr:string;
   public
    _prop_Title:string;
    _prop_CodePage:integer;

    _data_Str:THI_Event;
    _event_onRead:THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure _work_doWrite(var _Data:TData; Index:word);
    procedure _work_doRead(var _Data:TData; Index:word);
    procedure _var_ReadStr(var _Data:TData; Index:word);
  end;

implementation

constructor THIExtConsole.Create;
begin
  inherited;
  AllocConsole;
  SetConsoleCP(_prop_CodePage);
  SetConsoleOutputCP(_prop_CodePage);
  SetConsoleTitle(PChar(_prop_Title));
end;

destructor THIExtConsole.Destroy;
begin
  FreeConsole;
  inherited;
end;

procedure THIExtConsole._work_doWrite;
begin
  Write(PChar(ReadString(_Data,_data_Str)));
end;

procedure THIExtConsole._work_doRead;
begin
  Readln(rstr);
  _hi_OnEvent(_event_onRead,rstr);
end;

procedure THIExtConsole._var_ReadStr;
begin
  dtString(_Data,rstr);
end;

end.
